| 123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926927928929930931932933934935936937938939940941942943944945946947948949950951952953954955956957958959960961962963964965966967968969970971972973974975976977978979980981982983984985986987988989990991992993994995996997998999100010011002100310041005100610071008100910101011101210131014101510161017101810191020102110221023102410251026102710281029103010311032103310341035103610371038103910401041104210431044104510461047104810491050105110521053105410551056105710581059106010611062106310641065106610671068106910701071107210731074107510761077107810791080108110821083108410851086108710881089109010911092109310941095109610971098109911001101110211031104110511061107110811091110111111121113111411151116111711181119112011211122112311241125112611271128112911301131113211331134113511361137113811391140114111421143114411451146114711481149115011511152115311541155115611571158115911601161116211631164116511661167116811691170117111721173117411751176117711781179118011811182118311841185118611871188118911901191119211931194119511961197119811991200120112021203120412051206120712081209121012111212121312141215121612171218121912201221122212231224122512261227122812291230123112321233123412351236123712381239124012411242124312441245124612471248124912501251125212531254125512561257125812591260126112621263126412651266126712681269127012711272127312741275127612771278127912801281128212831284128512861287128812891290129112921293129412951296129712981299130013011302130313041305130613071308130913101311131213131314131513161317131813191320132113221323132413251326132713281329133013311332133313341335133613371338133913401341134213431344134513461347134813491350135113521353135413551356135713581359136013611362136313641365136613671368136913701371137213731374137513761377137813791380138113821383138413851386138713881389139013911392139313941395139613971398139914001401140214031404140514061407140814091410141114121413141414151416141714181419142014211422142314241425142614271428142914301431143214331434143514361437143814391440144114421443144414451446144714481449145014511452145314541455145614571458145914601461146214631464146514661467146814691470147114721473147414751476147714781479148014811482148314841485 |
- #!/bin/bash
- # Hestia Ubuntu installer v1.0
- #----------------------------------------------------------#
- # Variables&Functions #
- #----------------------------------------------------------#
- export PATH=$PATH:/sbin
- export DEBIAN_FRONTEND=noninteractive
- RHOST='apt.hestiacp.com'
- GPG='gpg.hestiacp.com'
- VERSION='ubuntu'
- HESTIA='/usr/local/hestia'
- LOG="/root/hst_install_backups/$(date +%s).log"
- memory=$(grep 'MemTotal' /proc/meminfo |tr ' ' '\n' |grep [0-9])
- hst_backups="/root/hst_install_backups/$(date +%s)"
- arch=$(uname -i)
- os='ubuntu'
- release="$(lsb_release -s -r)"
- codename="$(lsb_release -s -c)"
- hestiacp="$HESTIA/install/$VERSION/$release"
- pma_v='4.8.3'
- # Defining software pack for all distros
- software="apache2 apache2.2-common apache2-suexec-custom apache2-utils
- apparmor-utils awstats bc bind9 bsdmainutils bsdutils clamav-daemon
- cron curl dnsutils dovecot-imapd dovecot-pop3d e2fslibs e2fsprogs exim4
- exim4-daemon-heavy expect fail2ban flex ftp git idn imagemagick
- libapache2-mod-fcgid libapache2-mod-php libapache2-mod-rpaf
- libapache2-mod-ruid2 lsof mc mariadb-client mariadb-common mariadb-server nginx
- ntpdate php-cgi php-common php-curl phpmyadmin php-mysql phppgadmin
- php-pgsql postgresql postgresql-contrib proftpd-basic quota roundcube-core
- roundcube-mysql roundcube-plugins rrdtool rssh spamassassin sudo hestia
- hestia-nginx hestia-php vim-common vsftpd webalizer whois zip"
- # Defining help function
- help() {
- echo "Usage: $0 [OPTIONS]
- -a, --apache Install Apache [yes|no] default: yes
- -n, --nginx Install Nginx [yes|no] default: yes
- -w, --phpfpm Install PHP-FPM [yes|no] default: no
- -o, --multiphp Install Multi-PHP [yes|no] default: no
- -v, --vsftpd Install Vsftpd [yes|no] default: yes
- -j, --proftpd Install ProFTPD [yes|no] default: no
- -k, --named Install Bind [yes|no] default: yes
- -m, --mysql Install MariaDB [yes|no] default: yes
- -g, --postgresql Install PostgreSQL [yes|no] default: no
- -x, --exim Install Exim [yes|no] default: yes
- -z, --dovecot Install Dovecot [yes|no] default: yes
- -c, --clamav Install ClamAV [yes|no] default: yes
- -t, --spamassassin Install SpamAssassin [yes|no] default: yes
- -i, --iptables Install Iptables [yes|no] default: yes
- -b, --fail2ban Install Fail2ban [yes|no] default: yes
- -q, --quota Filesystem Quota [yes|no] default: no
- -d, --api Activate API [yes|no] default: yes
- -r, --port Change Backend Port default: 8083
- -l, --lang Default language default: en
- -y, --interactive Interactive install [yes|no] default: yes
- -s, --hostname Set hostname
- -e, --email Set admin email
- -p, --password Set admin password
- -f, --force Force installation
- -h, --help Print this help
- Example: bash $0 -e demo@hestiacp.com -p p4ssw0rd --apache no --phpfpm yes"
- exit 1
- }
- # Defining password-gen function
- gen_pass() {
- MATRIX='0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'
- LENGTH=16
- while [ ${n:=1} -le $LENGTH ]; do
- PASS="$PASS${MATRIX:$(($RANDOM%${#MATRIX})):1}"
- let n+=1
- done
- echo "$PASS"
- }
- # Defining return code check function
- check_result() {
- if [ $1 -ne 0 ]; then
- echo "Error: $2"
- exit $1
- fi
- }
- # Defining function to set default value
- set_default_value() {
- eval variable=\$$1
- if [ -z "$variable" ]; then
- eval $1=$2
- fi
- if [ "$variable" != 'yes' ] && [ "$variable" != 'no' ]; then
- eval $1=$2
- fi
- }
- # Defining function to set default language value
- set_default_lang() {
- if [ -z "$lang" ]; then
- eval lang=$1
- fi
- lang_list="
- ar cz el fa hu ja no pt se ua
- bs da en fi id ka pl ro tr vi
- cn de es fr it nl pt-BR ru tw
- bg ko sr th ur"
- if !(echo $lang_list |grep -w $lang > /dev/null 2>&1); then
- eval lang=$1
- fi
- }
- # Define the default backend port
- set_default_port() {
- if [ -z "$port" ]; then
- eval port=$1
- fi
- }
- #----------------------------------------------------------#
- # Verifications #
- #----------------------------------------------------------#
- # Creating temporary file
- tmpfile=$(mktemp -p /tmp)
- # Translating argument to --gnu-long-options
- for arg; do
- delim=""
- case "$arg" in
- --apache) args="${args}-a " ;;
- --nginx) args="${args}-n " ;;
- --phpfpm) args="${args}-w " ;;
- --vsftpd) args="${args}-v " ;;
- --proftpd) args="${args}-j " ;;
- --named) args="${args}-k " ;;
- --mysql) args="${args}-m " ;;
- --postgresql) args="${args}-g " ;;
- --exim) args="${args}-x " ;;
- --dovecot) args="${args}-z " ;;
- --clamav) args="${args}-c " ;;
- --spamassassin) args="${args}-t " ;;
- --iptables) args="${args}-i " ;;
- --fail2ban) args="${args}-b " ;;
- --multiphp) args="${args}-o " ;;
- --quota) args="${args}-q " ;;
- --port) args="${args}-r " ;;
- --lang) args="${args}-l " ;;
- --interactive) args="${args}-y " ;;
- --api) args="${args}-d " ;;
- --hostname) args="${args}-s " ;;
- --email) args="${args}-e " ;;
- --password) args="${args}-p " ;;
- --force) args="${args}-f " ;;
- --help) args="${args}-h " ;;
- *) [[ "${arg:0:1}" == "-" ]] || delim="\""
- args="${args}${delim}${arg}${delim} ";;
- esac
- done
- eval set -- "$args"
- # Parsing arguments
- while getopts "a:n:w:v:j:k:m:g:d:x:z:c:t:i:b:r:o:q:l:y:s:e:p:fh" Option; do
- case $Option in
- a) apache=$OPTARG ;; # Apache
- n) nginx=$OPTARG ;; # Nginx
- w) phpfpm=$OPTARG ;; # PHP-FPM
- o) multiphp=$OPTARG ;; # Multi-PHP
- v) vsftpd=$OPTARG ;; # Vsftpd
- j) proftpd=$OPTARG ;; # Proftpd
- k) named=$OPTARG ;; # Named
- m) mysql=$OPTARG ;; # MariaDB
- g) postgresql=$OPTARG ;; # PostgreSQL
- x) exim=$OPTARG ;; # Exim
- z) dovecot=$OPTARG ;; # Dovecot
- c) clamd=$OPTARG ;; # ClamAV
- t) spamd=$OPTARG ;; # SpamAssassin
- i) iptables=$OPTARG ;; # Iptables
- b) fail2ban=$OPTARG ;; # Fail2ban
- q) quota=$OPTARG ;; # FS Quota
- r) port=$OPTARG ;; # Backend Port
- l) lang=$OPTARG ;; # Language
- d) api=$OPTARG ;; # Activate API
- y) interactive=$OPTARG ;; # Interactive install
- s) servername=$OPTARG ;; # Hostname
- e) email=$OPTARG ;; # Admin email
- p) vpass=$OPTARG ;; # Admin password
- f) force='yes' ;; # Force install
- h) help ;; # Help
- *) help ;; # Print help (default)
- esac
- done
- # Defining default software stack
- set_default_value 'nginx' 'yes'
- set_default_value 'apache' 'yes'
- set_default_value 'phpfpm' 'no'
- set_default_value 'multiphp' 'no'
- set_default_value 'vsftpd' 'yes'
- set_default_value 'proftpd' 'no'
- set_default_value 'named' 'yes'
- set_default_value 'mysql' 'yes'
- set_default_value 'postgresql' 'no'
- set_default_value 'exim' 'yes'
- set_default_value 'dovecot' 'yes'
- if [ $memory -lt 1500000 ]; then
- set_default_value 'clamd' 'no'
- set_default_value 'spamd' 'no'
- else
- set_default_value 'clamd' 'yes'
- set_default_value 'spamd' 'yes'
- fi
- set_default_value 'iptables' 'yes'
- set_default_value 'fail2ban' 'yes'
- set_default_value 'quota' 'no'
- set_default_value 'interactive' 'yes'
- set_default_value 'api' 'yes'
- set_default_port '8083'
- set_default_lang 'en'
- # Checking software conflicts
- if [ "$phpfpm" = 'yes' ]; then
- apache='no'
- nginx='yes'
- fi
- if [ "$multiphp" = 'yes' ]; then
- phpfpm='no'
- fi
- if [ "$proftpd" = 'yes' ]; then
- vsftpd='no'
- fi
- if [ "$exim" = 'no' ]; then
- clamd='no'
- spamd='no'
- dovecot='no'
- fi
- if [ "$iptables" = 'no' ]; then
- fail2ban='no'
- fi
- # Checking root permissions
- if [ "x$(id -u)" != 'x0' ]; then
- check_result 1 "Script can be run executed only by root"
- fi
- # Checking admin user account
- if [ ! -z "$(grep ^admin: /etc/passwd /etc/group)" ] && [ -z "$force" ]; then
- echo 'Please remove admin user account before proceeding.'
- echo 'If you want to do it automatically run installer with -f option:'
- echo -e "Example: bash $0 --force\n"
- check_result 1 "User admin exists"
- fi
- # Update apt repository
- echo "Please wait a few seconds, we update your repository before we start the installation process..."
- apt-get -qq update
- # Creating backup directory
- mkdir -p $hst_backups
- # Checking wget
- if [ ! -e '/usr/bin/wget' ]; then
- echo "Install missing wget..."
- apt-get -y install wget >> $LOG
- check_result $? "Can't install wget"
- fi
- # Check if apt-transport-https is installed
- if [ ! -e '/usr/lib/apt/methods/https' ]; then
- echo "Install missing apt-transport-https..."
- apt-get -y install apt-transport-https >> $LOG
- check_result $? "Can't install apt-transport-https"
- fi
- # Check if apt-add-repository is installed
- if [ ! -e '/usr/bin/apt-add-repository' ]; then
- echo "Install missing apt-add-repository..."
- apt-get -y install python-software-properties >> $LOG
- check_result $? "Can't install python-software-properties"
- fi
- # Checking repository availability
- wget --quiet "https://$GPG/deb_signing.key" -O /dev/null
- check_result $? "No access to Hestia repository"
- # Checking installed packages
- tmpfile=$(mktemp -p /tmp)
- dpkg --get-selections > $tmpfile
- for pkg in exim4 mariadb-server apache2 nginx hestia; do
- if [ ! -z "$(grep $pkg $tmpfile)" ]; then
- conflicts="$pkg $conflicts"
- fi
- done
- rm -f $tmpfile
- if [ ! -z "$conflicts" ] && [ -z "$force" ]; then
- echo '!!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!!'
- echo
- echo 'Following packages are already installed:'
- echo "$conflicts"
- echo
- echo 'It is highly recommended to remove them before proceeding.'
- echo 'If you want to force installation run this script with -f option:'
- echo "Example: bash $0 --force"
- echo
- echo '!!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!! !!!'
- echo
- check_result 1 "Control Panel should be installed on clean server."
- fi
- #----------------------------------------------------------#
- # Brief Info #
- #----------------------------------------------------------#
- # Printing nice ASCII logo
- clear
- echo
- echo ' _ _ _ _ ____ ____ '
- echo ' | | | | ___ ___| |_(_) __ _ / ___| _ \ '
- echo ' | |_| |/ _ \/ __| __| |/ _` | | | |_) |'
- echo ' | _ | __/\__ \ |_| | (_| | |___| __/ '
- echo ' |_| |_|\___||___/\__|_|\__,_|\____|_| '
- echo
- echo ' Hestia Control Panel'
- echo -e "\n\n"
- echo 'The following software will be installed on your system:'
- # Web stack
- if [ "$nginx" = 'yes' ]; then
- echo ' - Nginx Web Server'
- fi
- if [ "$apache" = 'yes' ] && [ "$nginx" = 'no' ] ; then
- echo ' - Apache Web Server'
- fi
- if [ "$apache" = 'yes' ] && [ "$nginx" = 'yes' ] ; then
- echo ' - Apache Web Server (as backend)'
- fi
- if [ "$phpfpm" = 'yes' ]; then
- echo ' - PHP-FPM Application Server'
- fi
- if [ "$multiphp" = 'yes' ]; then
- echo ' - Multi-PHP Environment'
- fi
- # DNS stack
- if [ "$named" = 'yes' ]; then
- echo ' - Bind DNS Server'
- fi
- # Mail stack
- if [ "$exim" = 'yes' ]; then
- echo -n ' - Exim Mail Server'
- if [ "$clamd" = 'yes' ] || [ "$spamd" = 'yes' ] ; then
- echo -n ' + '
- if [ "$clamd" = 'yes' ]; then
- echo -n 'ClamAV'
- fi
- if [ "$spamd" = 'yes' ]; then
- echo -n 'SpamAssassin'
- fi
- fi
- echo
- if [ "$dovecot" = 'yes' ]; then
- echo ' - Dovecot POP3/IMAP Server'
- fi
- fi
- # Database stack
- if [ "$mysql" = 'yes' ]; then
- echo ' - MariaDB Database Server'
- fi
- if [ "$postgresql" = 'yes' ]; then
- echo ' - PostgreSQL Database Server'
- fi
- # FTP stack
- if [ "$vsftpd" = 'yes' ]; then
- echo ' - Vsftpd FTP Server'
- fi
- if [ "$proftpd" = 'yes' ]; then
- echo ' - ProFTPD FTP Server'
- fi
- # Firewall stack
- if [ "$iptables" = 'yes' ]; then
- echo -n ' - Iptables Firewall'
- fi
- if [ "$iptables" = 'yes' ] && [ "$fail2ban" = 'yes' ]; then
- echo -n ' + Fail2Ban'
- fi
- echo -e "\n\n"
- # Asking for confirmation to proceed
- if [ "$interactive" = 'yes' ]; then
- read -p 'Would you like to continue [y/n]: ' answer
- if [ "$answer" != 'y' ] && [ "$answer" != 'Y' ]; then
- echo 'Goodbye'
- exit 1
- fi
- # Asking for contact email
- if [ -z "$email" ]; then
- read -p 'Please enter admin email address: ' email
- fi
- # Asking to set FQDN hostname
- if [ -z "$servername" ]; then
- read -p "Please enter FQDN hostname [$(hostname -f)]: " servername
- fi
- fi
- # Generating admin password if it wasn't set
- if [ -z "$vpass" ]; then
- vpass=$(gen_pass)
- fi
- # Set hostname if it wasn't set
- if [ -z "$servername" ]; then
- servername=$(hostname -f)
- fi
- # Set FQDN if it wasn't set
- mask1='(([[:alnum:]](-?[[:alnum:]])*)\.)'
- mask2='*[[:alnum:]](-?[[:alnum:]])+\.[[:alnum:]]{2,}'
- if ! [[ "$servername" =~ ^${mask1}${mask2}$ ]]; then
- if [ ! -z "$servername" ]; then
- servername="$servername.example.com"
- else
- servername="example.com"
- fi
- echo "127.0.0.1 $servername" >> /etc/hosts
- fi
- # Set email if it wasn't set
- if [ -z "$email" ]; then
- email="admin@$servername"
- fi
- # Defining backup directory
- echo "Installation backup directory: $hst_backups"
- # Print Log File Path
- echo "Installation Log File: $LOG"
- # Printing start message and sleeping for 2 seconds
- echo -e "\n\nWe will now install HestiaCP and all required packages. The process will take around 10-15 minutes...\n"
- sleep 2
- #----------------------------------------------------------#
- # Checking swap #
- #----------------------------------------------------------#
- # Checking swap on small instances
- if [ -z "$(swapon -s)" ] && [ $memory -lt 1000000 ]; then
- fallocate -l 1G /swapfile
- chmod 600 /swapfile
- mkswap /swapfile
- swapon /swapfile
- echo "/swapfile none swap sw 0 0" >> /etc/fstab
- fi
- #----------------------------------------------------------#
- # Install repository #
- #----------------------------------------------------------#
- # Updating system
- echo "Upgrade System using apt-get..."
- apt-get -y upgrade >> $LOG
- check_result $? 'apt-get upgrade failed'
- # Define apt conf location
- apt=/etc/apt/sources.list.d
- # Installing nginx repo
- echo "deb http://nginx.org/packages/mainline/$VERSION/ $codename nginx" \
- > $apt/nginx.list
- wget --quiet http://nginx.org/keys/nginx_signing.key -O /tmp/nginx_signing.key
- apt-key add /tmp/nginx_signing.key >> $LOG
- if [ "$multiphp" = 'yes' ] || [ "$phpfpm" = 'yes' ]; then
- # Installing sury php repo
- add-apt-repository -y ppa:ondrej/php >> $LOG
- fi
- # Installing MariaDB repo
- echo "deb http://ams2.mirrors.digitalocean.com/mariadb/repo/10.3/$VERSION $codename main" > $apt/mariadb.list
- apt-key adv --recv-keys --keyserver keyserver.ubuntu.com 0xF1656F24C74CD1D8 >> $LOG
- # Installing hestia repo
- echo "deb https://$RHOST/ $codename main" > $apt/hestia.list
- wget --quiet https://gpg.hestiacp.com/deb_signing.key -O /tmp/deb_signing.key
- apt-key add /tmp/deb_signing.key >> $LOG
- #----------------------------------------------------------#
- # Backup #
- #----------------------------------------------------------#
- # Creating backup directory tree
- cd $hst_backups
- mkdir nginx apache2 php vsftpd proftpd bind exim4 dovecot clamd
- mkdir spamassassin mysql postgresql hestia
- # Backup nginx configuration
- service nginx stop > /dev/null 2>&1
- cp -r /etc/nginx/* $hst_backups/nginx > /dev/null 2>&1
- # Backup Apache configuration
- service apache2 stop > /dev/null 2>&1
- cp -r /etc/apache2/* $hst_backups/apache2 > /dev/null 2>&1
- rm -f /etc/apache2/conf.d/* > /dev/null 2>&1
- # Backup PHP-FPM configuration
- service php*-fpm stop > /dev/null 2>&1
- cp -r /etc/php/* $hst_backups/php/ > /dev/null 2>&1
- # Backup Bind configuration
- service bind9 stop > /dev/null 2>&1
- cp -r /etc/bind/* $hst_backups/bind > /dev/null 2>&1
- # Backup Vsftpd configuration
- service vsftpd stop > /dev/null 2>&1
- cp /etc/vsftpd.conf $hst_backups/vsftpd > /dev/null 2>&1
- # Backup ProFTPD configuration
- service proftpd stop > /dev/null 2>&1
- cp /etc/proftpd.conf $hst_backups/proftpd > /dev/null 2>&1
- # Backup Exim configuration
- service exim4 stop > /dev/null 2>&1
- cp -r /etc/exim4/* $hst_backups/exim4 > /dev/null 2>&1
- # Backup ClamAV configuration
- service clamav-daemon stop > /dev/null 2>&1
- cp -r /etc/clamav/* $hst_backups/clamav > /dev/null 2>&1
- # Backup SpamAssassin configuration
- service spamassassin stop > /dev/null 2>&1
- cp -r /etc/spamassassin/* $hst_backups/spamassassin > /dev/null 2>&1
- # Backup Dovecot configuration
- service dovecot stop > /dev/null 2>&1
- cp /etc/dovecot.conf $hst_backups/dovecot > /dev/null 2>&1
- cp -r /etc/dovecot/* $hst_backups/dovecot > /dev/null 2>&1
- # Backup MySQL/MariaDB configuration and data
- service mysql stop > /dev/null 2>&1
- killall -9 mysqld > /dev/null 2>&1
- mv /var/lib/mysql $hst_backups/mysql/mysql_datadir > /dev/null 2>&1
- cp -r /etc/mysql/* $hst_backups/mysql > /dev/null 2>&1
- mv -f /root/.my.cnf $hst_backups/mysql > /dev/null 2>&1
- # Backup Hestia
- service hestia stop > /dev/null 2>&1
- cp -r $HESTIA/* $hst_backups/hestia > /dev/null 2>&1
- apt-get -y purge hestia hestia-nginx hestia-php > /dev/null 2>&1
- rm -rf $HESTIA > /dev/null 2>&1
- #----------------------------------------------------------#
- # Package Excludes #
- #----------------------------------------------------------#
- # Excluding packages
- software=$(echo "$software" | sed -e "s/apache2.2-common//")
- if [ "$nginx" = 'no' ]; then
- software=$(echo "$software" | sed -e "s/^nginx//")
- fi
- if [ "$apache" = 'no' ]; then
- software=$(echo "$software" | sed -e "s/apache2 //")
- software=$(echo "$software" | sed -e "s/apache2-utils//")
- software=$(echo "$software" | sed -e "s/apache2-suexec-custom//")
- software=$(echo "$software" | sed -e "s/apache2.2-common//")
- software=$(echo "$software" | sed -e "s/libapache2-mod-ruid2//")
- software=$(echo "$software" | sed -e "s/libapache2-mod-rpaf//")
- software=$(echo "$software" | sed -e "s/libapache2-mod-fcgid//")
- software=$(echo "$software" | sed -e "s/libapache2-mod-php7.2//")
- software=$(echo "$software" | sed -e "s/libapache2-mod-php//")
- fi
- if [ "$vsftpd" = 'no' ]; then
- software=$(echo "$software" | sed -e "s/vsftpd//")
- fi
- if [ "$proftpd" = 'no' ]; then
- software=$(echo "$software" | sed -e "s/proftpd-basic//")
- software=$(echo "$software" | sed -e "s/proftpd-mod-vroot//")
- fi
- if [ "$named" = 'no' ]; then
- software=$(echo "$software" | sed -e "s/bind9//")
- fi
- if [ "$exim" = 'no' ]; then
- software=$(echo "$software" | sed -e "s/exim4 //")
- software=$(echo "$software" | sed -e "s/exim4-daemon-heavy//")
- software=$(echo "$software" | sed -e "s/dovecot-imapd//")
- software=$(echo "$software" | sed -e "s/dovecot-pop3d//")
- software=$(echo "$software" | sed -e "s/clamav-daemon//")
- software=$(echo "$software" | sed -e "s/spamassassin//")
- fi
- if [ "$clamd" = 'no' ]; then
- software=$(echo "$software" | sed -e "s/clamav-daemon//")
- fi
- if [ "$spamd" = 'no' ]; then
- software=$(echo "$software" | sed -e "s/spamassassin//")
- fi
- if [ "$dovecot" = 'no' ]; then
- software=$(echo "$software" | sed -e "s/dovecot-imapd//")
- software=$(echo "$software" | sed -e "s/dovecot-pop3d//")
- fi
- if [ "$mysql" = 'no' ]; then
- software=$(echo "$software" | sed -e 's/mariadb-server//')
- software=$(echo "$software" | sed -e 's/mariadb-client//')
- software=$(echo "$software" | sed -e 's/mariadb-common//')
- software=$(echo "$software" | sed -e 's/php7.2-mysql//')
- software=$(echo "$software" | sed -e 's/php-mysql//')
- software=$(echo "$software" | sed -e 's/phpMyAdmin//')
- software=$(echo "$software" | sed -e 's/phpmyadmin//')
- fi
- if [ "$postgresql" = 'no' ]; then
- software=$(echo "$software" | sed -e 's/postgresql-contrib//')
- software=$(echo "$software" | sed -e 's/postgresql//')
- software=$(echo "$software" | sed -e 's/php7.2-pgsql//')
- software=$(echo "$software" | sed -e 's/php-pgsql//')
- software=$(echo "$software" | sed -e 's/phppgadmin//')
- fi
- if [ "$iptables" = 'no' ] || [ "$fail2ban" = 'no' ]; then
- software=$(echo "$software" | sed -e 's/fail2ban//')
- fi
- #----------------------------------------------------------#
- # Package Includes #
- #----------------------------------------------------------#
- if [ "$multiphp" = 'yes' ]; then
- mph="php5.6-apcu php5.6-mbstring php5.6-bcmath php5.6-cli php5.6-curl
- php5.6-fpm php5.6-gd php5.6-intl php5.6-mcrypt php5.6-mysql
- php5.6-soap php5.6-xml php5.6-zip php7.0-mbstring php7.0-bcmath
- php7.0-cli php7.0-curl php7.0-fpm php7.0-gd php7.0-intl php7.0-mcrypt
- php7.0-mysql php7.0-soap php7.0-xml php7.0-zip php7.1-mbstring
- php7.1-bcmath php7.1-cli php7.1-curl php7.1-fpm php7.1-gd php7.1-intl
- php7.1-mcrypt php7.1-mysql php7.1-soap php7.1-xml php7.1-zip
- php7.2-mbstring php7.2-bcmath php7.2-cli php7.2-curl php7.2-fpm
- php7.2-gd php7.2-intl php7.2-mysql php7.2-soap php7.2-xml
- php7.2-zip php7.3-mbstring php7.3-bcmath php7.3-cli php7.3-curl
- php7.3-fpm php7.3-gd php7.3-intl php7.3-mysql php7.3-soap php7.3-xml
- php7.3-zip"
- software="$software $mph"
- fi
- if [ "$phpfpm" = 'yes' ]; then
- fpm="php7.2-mbstring php7.2-bcmath php7.2-cli php7.2-curl php7.2-fpm
- php7.2-gd php7.2-intl php7.2-mysql php7.2-soap php7.2-xml
- php7.2-zip"
- software="$software $fpm"
- fi
- #----------------------------------------------------------#
- # Install packages #
- #----------------------------------------------------------#
- # Updating system
- apt-get -qq update
- # Disabling daemon autostart on apt-get install
- echo -e '#!/bin/sh\nexit 101' > /usr/sbin/policy-rc.d
- chmod a+x /usr/sbin/policy-rc.d
- # Installing apt packages
- apt-get -y install $software >> $LOG
- check_result $? "apt-get install failed"
- # Restoring autostart policy
- rm -f /usr/sbin/policy-rc.d
- #----------------------------------------------------------#
- # Configure system #
- #----------------------------------------------------------#
- # Enable SSH password authentication
- sed -i "s/rdAuthentication no/rdAuthentication yes/g" /etc/ssh/sshd_config
- # Disable SSH suffix broadcast
- echo '' >> /etc/ssh/sshd_config
- echo 'DebianBanner no' >> /etc/ssh/sshd_config
- service ssh restart
- # Disable AWStats cron
- rm -f /etc/cron.d/awstats
- # Set directory color
- echo 'LS_COLORS="$LS_COLORS:di=00;33"' >> /etc/profile
- # Registering /usr/sbin/nologin
- if [ -z "$(grep nologin /etc/shells)" ]; then
- echo "/usr/sbin/nologin" >> /etc/shells
- fi
- # Configuring NTP
- echo '#!/bin/sh' > /etc/cron.daily/ntpdate
- echo "$(which ntpdate) -s pool.ntp.org" >> /etc/cron.daily/ntpdate
- chmod 755 /etc/cron.daily/ntpdate
- ntpdate -s pool.ntp.org
- # Adding rssh
- if [ -z "$(grep /usr/bin/rssh /etc/shells)" ]; then
- echo /usr/bin/rssh >> /etc/shells
- fi
- sed -i 's/#allowscp/allowscp/' /etc/rssh.conf
- sed -i 's/#allowsftp/allowsftp/' /etc/rssh.conf
- sed -i 's/#allowrsync/allowrsync/' /etc/rssh.conf
- chmod 755 /usr/bin/rssh
- #----------------------------------------------------------#
- # Configure Hestia #
- #----------------------------------------------------------#
- # Installing sudo configuration
- mkdir -p /etc/sudoers.d
- cp -f $hestiacp/sudo/admin /etc/sudoers.d/
- chmod 440 /etc/sudoers.d/admin
- # Configuring system env
- echo "export HESTIA='$HESTIA'" > /etc/profile.d/hestia.sh
- echo "export VESTA='$HESTIA'" >> /etc/profile.d/hestia.sh # Vesta compatibility
- chmod 755 /etc/profile.d/hestia.sh
- source /etc/profile.d/hestia.sh
- echo 'PATH=$PATH:'$HESTIA'/bin' >> /root/.bash_profile
- echo 'export PATH' >> /root/.bash_profile
- source /root/.bash_profile
- # Configuring logrotate for Hestia logs
- cp -f $hestiacp/logrotate/hestia /etc/logrotate.d/hestia
- # Building directory tree and creating some blank files for Hestia
- mkdir -p $HESTIA/conf $HESTIA/log $HESTIA/ssl $HESTIA/data/ips \
- $HESTIA/data/queue $HESTIA/data/users $HESTIA/data/firewall \
- $HESTIA/data/sessions
- touch $HESTIA/data/queue/backup.pipe $HESTIA/data/queue/disk.pipe \
- $HESTIA/data/queue/webstats.pipe $HESTIA/data/queue/restart.pipe \
- $HESTIA/data/queue/traffic.pipe $HESTIA/log/system.log \
- $HESTIA/log/nginx-error.log $HESTIA/log/auth.log
- chmod 750 $HESTIA/conf $HESTIA/data/users $HESTIA/data/ips $HESTIA/log
- chmod -R 750 $HESTIA/data/queue
- chmod 660 $HESTIA/log/*
- rm -f /var/log/hestia
- ln -s $HESTIA/log /var/log/hestia
- chmod 770 $HESTIA/data/sessions
- # Generating Hestia configuration
- rm -f $HESTIA/conf/hestia.conf 2>/dev/null
- touch $HESTIA/conf/hestia.conf
- chmod 660 $HESTIA/conf/hestia.conf
- # Symlink to Vesta for compatibilty
- ln -s $HESTIA /usr/local/vesta
- ln -s $HESTIA/conf/hestia.conf /usr/local/vesta/conf/vesta.conf
- # Web stack
- if [ "$apache" = 'yes' ] && [ "$nginx" = 'no' ] ; then
- echo "WEB_SYSTEM='apache2'" >> $HESTIA/conf/hestia.conf
- echo "WEB_RGROUPS='www-data'" >> $HESTIA/conf/hestia.conf
- echo "WEB_PORT='80'" >> $HESTIA/conf/hestia.conf
- echo "WEB_SSL_PORT='443'" >> $HESTIA/conf/hestia.conf
- echo "WEB_SSL='mod_ssl'" >> $HESTIA/conf/hestia.conf
- echo "STATS_SYSTEM='webalizer,awstats'" >> $HESTIA/conf/hestia.conf
- fi
- if [ "$apache" = 'yes' ] && [ "$nginx" = 'yes' ] ; then
- echo "WEB_SYSTEM='apache2'" >> $HESTIA/conf/hestia.conf
- echo "WEB_RGROUPS='www-data'" >> $HESTIA/conf/hestia.conf
- echo "WEB_PORT='8080'" >> $HESTIA/conf/hestia.conf
- echo "WEB_SSL_PORT='8443'" >> $HESTIA/conf/hestia.conf
- echo "WEB_SSL='mod_ssl'" >> $HESTIA/conf/hestia.conf
- echo "PROXY_SYSTEM='nginx'" >> $HESTIA/conf/hestia.conf
- echo "PROXY_PORT='80'" >> $HESTIA/conf/hestia.conf
- echo "PROXY_SSL_PORT='443'" >> $HESTIA/conf/hestia.conf
- echo "STATS_SYSTEM='webalizer,awstats'" >> $HESTIA/conf/hestia.conf
- fi
- if [ "$apache" = 'no' ] && [ "$nginx" = 'yes' ]; then
- echo "WEB_SYSTEM='nginx'" >> $HESTIA/conf/hestia.conf
- echo "WEB_PORT='80'" >> $HESTIA/conf/hestia.conf
- echo "WEB_SSL_PORT='443'" >> $HESTIA/conf/hestia.conf
- echo "WEB_SSL='openssl'" >> $HESTIA/conf/hestia.conf
- if [ "$phpfpm" = 'yes' ]; then
- echo "WEB_BACKEND='php-fpm'" >> $HESTIA/conf/hestia.conf
- fi
- echo "STATS_SYSTEM='webalizer,awstats'" >> $HESTIA/conf/hestia.conf
- fi
- # FTP stack
- if [ "$vsftpd" = 'yes' ]; then
- echo "FTP_SYSTEM='vsftpd'" >> $HESTIA/conf/hestia.conf
- fi
- if [ "$proftpd" = 'yes' ]; then
- echo "FTP_SYSTEM='proftpd'" >> $HESTIA/conf/hestia.conf
- fi
- # DNS stack
- if [ "$named" = 'yes' ]; then
- echo "DNS_SYSTEM='bind9'" >> $HESTIA/conf/hestia.conf
- fi
- # Mail stack
- if [ "$exim" = 'yes' ]; then
- echo "MAIL_SYSTEM='exim4'" >> $HESTIA/conf/hestia.conf
- if [ "$clamd" = 'yes' ]; then
- echo "ANTIVIRUS_SYSTEM='clamav-daemon'" >> $HESTIA/conf/hestia.conf
- fi
- if [ "$spamd" = 'yes' ]; then
- echo "ANTISPAM_SYSTEM='spamassassin'" >> $HESTIA/conf/hestia.conf
- fi
- if [ "$dovecot" = 'yes' ]; then
- echo "IMAP_SYSTEM='dovecot'" >> $HESTIA/conf/hestia.conf
- fi
- fi
- # Cron daemon
- echo "CRON_SYSTEM='cron'" >> $HESTIA/conf/hestia.conf
- # Firewall stack
- if [ "$iptables" = 'yes' ]; then
- echo "FIREWALL_SYSTEM='iptables'" >> $HESTIA/conf/hestia.conf
- fi
- if [ "$iptables" = 'yes' ] && [ "$fail2ban" = 'yes' ]; then
- echo "FIREWALL_EXTENSION='fail2ban'" >> $HESTIA/conf/hestia.conf
- fi
- # Disk quota
- if [ "$quota" = 'yes' ]; then
- echo "DISK_QUOTA='yes'" >> $HESTIA/conf/hestia.conf
- fi
- # Backups
- echo "BACKUP_SYSTEM='local'" >> $HESTIA/conf/hestia.conf
- # Language
- echo "LANGUAGE='$lang'" >> $HESTIA/conf/hestia.conf
- # Version
- echo "VERSION='0.9.8'" >> $HESTIA/conf/hestia.conf
- # Installing hosting packages
- cp -rf $hestiacp/packages $HESTIA/data/
- # Installing templates
- cp -rf $hestiacp/templates $HESTIA/data/
- # Copying index.html to default documentroot
- cp $HESTIA/data/templates/web/skel/public_html/index.html /var/www/
- sed -i 's/%domain%/It worked!/g' /var/www/index.html
- # Installing firewall rules
- cp -rf $hestiacp/firewall $HESTIA/data/
- # Configuring server hostname
- $HESTIA/bin/v-change-sys-hostname $servername 2>/dev/null
- # Generating SSL certificate
- $HESTIA/bin/v-generate-ssl-cert $(hostname) $email 'US' 'California' \
- 'San Francisco' 'Hestia Control Panel' 'IT' > /tmp/hst.pem
- # Parsing certificate file
- crt_end=$(grep -n "END CERTIFICATE-" /tmp/hst.pem |cut -f 1 -d:)
- key_start=$(grep -n "BEGIN RSA" /tmp/hst.pem |cut -f 1 -d:)
- key_end=$(grep -n "END RSA" /tmp/hst.pem |cut -f 1 -d:)
- # Adding SSL certificate
- cd $HESTIA/ssl
- sed -n "1,${crt_end}p" /tmp/hst.pem > certificate.crt
- sed -n "$key_start,${key_end}p" /tmp/hst.pem > certificate.key
- chown root:mail $HESTIA/ssl/*
- chmod 660 $HESTIA/ssl/*
- rm /tmp/hst.pem
- # Adding nologin as a valid system shell
- if [ -z "$(grep nologin /etc/shells)" ]; then
- echo "/usr/sbin/nologin" >> /etc/shells
- fi
- #----------------------------------------------------------#
- # Configure Nginx #
- #----------------------------------------------------------#
- if [ "$nginx" = 'yes' ]; then
- rm -f /etc/nginx/conf.d/*.conf
- cp -f $hestiacp/nginx/nginx.conf /etc/nginx/
- cp -f $hestiacp/nginx/status.conf /etc/nginx/conf.d/
- cp -f $hestiacp/nginx/phpmyadmin.inc /etc/nginx/conf.d/
- cp -f $hestiacp/nginx/phppgadmin.inc /etc/nginx/conf.d/
- cp -f $hestiacp/nginx/webmail.inc /etc/nginx/conf.d/
- cp -f $hestiacp/logrotate/nginx /etc/logrotate.d/
- echo > /etc/nginx/conf.d/hestia.conf
- mkdir -p /var/log/nginx/domains
- if [ "$apache" = 'no' ] && [ "$multiphp" = 'yes' ]; then
- update-rc.d php5.6-fpm defaults > /dev/null 2>&1
- update-rc.d php7.0-fpm defaults > /dev/null 2>&1
- update-rc.d php7.1-fpm defaults > /dev/null 2>&1
- update-rc.d php7.2-fpm defaults > /dev/null 2>&1
- update-rc.d php7.3-fpm defaults > /dev/null 2>&1
- cp -r /etc/php/5.6/ /root/hst_install_backups/php5.6/
- rm -f /etc/php/5.6/fpm/pool.d/*
- cp -r /etc/php/7.0/ /root/hst_install_backups/php7.0/
- rm -f /etc/php/7.0/fpm/pool.d/*
- cp -r /etc/php/7.1/ /root/hst_install_backups/php7.1/
- rm -f /etc/php/7.1/fpm/pool.d/*
- cp -r /etc/php/7.2/ /root/hst_install_backups/php7.2/
- rm -f /etc/php/7.2/fpm/pool.d/*
- cp -r /etc/php/7.3/ /root/hst_install_backups/php7.3/
- rm -f /etc/php/7.3/fpm/pool.d/*
- rm -fr $HESTIA/data/templates/web/nginx/*
- cp -f $hestiacp/multiphp/nginx/* $HESTIA/data/templates/web/nginx/
- cp -f $hestiacp/php-fpm/www.conf /etc/php/7.2/fpm/pool.d/
- ln -s $HESTIA/data/templates/web/nginx/PHP-72.sh $HESTIA/data/templates/web/nginx/default.sh
- ln -s $HESTIA/data/templates/web/nginx/PHP-72.tpl $HESTIA/data/templates/web/nginx/default.tpl
- ln -s $HESTIA/data/templates/web/nginx/PHP-72.stpl $HESTIA/data/templates/web/nginx/default.stpl
- chmod a+x $HESTIA/data/templates/web/nginx/*.sh
- service php7.2-fpm start > /dev/null 2>&1
- check_result $? "php7.2-fpm start failed"
- fi
- update-rc.d nginx defaults > /dev/null 2>&1
- service nginx start >> $LOG
- check_result $? "nginx start failed"
- fi
- #----------------------------------------------------------#
- # Configure Apache #
- #----------------------------------------------------------#
- if [ "$apache" = 'yes' ]; then
- cp -f $hestiacp/apache2/apache2.conf /etc/apache2/
- cp -f $hestiacp/apache2/status.conf /etc/apache2/mods-enabled/
- cp -f $hestiacp/logrotate/apache2 /etc/logrotate.d/
- a2enmod rewrite > /dev/null 2>&1
- a2enmod suexec > /dev/null 2>&1
- a2enmod ssl > /dev/null 2>&1
- a2enmod actions > /dev/null 2>&1
- a2enmod ruid2 > /dev/null 2>&1
- mkdir -p /etc/apache2/conf.d
- echo > /etc/apache2/conf.d/hestia.conf
- echo "# Powered by hestia" > /etc/apache2/sites-available/default
- echo "# Powered by hestia" > /etc/apache2/sites-available/default-ssl
- echo "# Powered by hestia" > /etc/apache2/ports.conf
- echo -e "/home\npublic_html/cgi-bin" > /etc/apache2/suexec/www-data
- touch /var/log/apache2/access.log /var/log/apache2/error.log
- mkdir -p /var/log/apache2/domains
- chmod a+x /var/log/apache2
- chmod 640 /var/log/apache2/access.log /var/log/apache2/error.log
- chmod 751 /var/log/apache2/domains
- if [ "$multiphp" = 'yes' ] ; then
- a2enmod proxy_fcgi setenvif > /dev/null 2>&1
- a2enconf php5.6-fpm > /dev/null 2>&1
- a2enconf php7.0-fpm > /dev/null 2>&1
- a2enconf php7.1-fpm > /dev/null 2>&1
- a2enconf php7.2-fpm > /dev/null 2>&1
- a2enconf php7.3-fpm > /dev/null 2>&1
- update-rc.d php5.6-fpm defaults > /dev/null 2>&1
- update-rc.d php7.0-fpm defaults > /dev/null 2>&1
- update-rc.d php7.1-fpm defaults > /dev/null 2>&1
- update-rc.d php7.2-fpm defaults > /dev/null 2>&1
- update-rc.d php7.3-fpm defaults > /dev/null 2>&1
- cp -r /etc/php/5.6/ /root/hst_install_backups/php5.6/
- rm -f /etc/php/5.6/fpm/pool.d/*
- cp -r /etc/php/7.0/ /root/hst_install_backups/php7.0/
- rm -f /etc/php/7.0/fpm/pool.d/*
- cp -r /etc/php/7.1/ /root/hst_install_backups/php7.1/
- rm -f /etc/php/7.1/fpm/pool.d/*
- cp -r /etc/php/7.2/ /root/hst_install_backups/php7.2/
- rm -f /etc/php/7.2/fpm/pool.d/*
- cp -r /etc/php/7.3/ /root/hst_install_backups/php7.3/
- rm -f /etc/php/7.3/fpm/pool.d/*
- cp -f $hestiacp/multiphp/apache2/* $HESTIA/data/templates/web/apache2/
- chmod a+x $HESTIA/data/templates/web/apache2/*.sh
- fi
- update-rc.d apache2 defaults > /dev/null 2>&1
- service apache2 start >> $LOG
- check_result $? "apache2 start failed"
- else
- update-rc.d apache2 disable > /dev/null 2>&1
- service apache2 stop >> $LOG
- fi
- #----------------------------------------------------------#
- # Configure PHP-FPM #
- #----------------------------------------------------------#
- if [ "$phpfpm" = 'yes' ]; then
- cp -f $hestiacp/php-fpm/www.conf /etc/php/7.2/fpm/pool.d/www.conf
- update-rc.d php7.2-fpm defaults > /dev/null 2>&1
- service php7.2-fpm start >> $LOG
- check_result $? "php-fpm start failed"
- fi
- #----------------------------------------------------------#
- # Configure PHP #
- #----------------------------------------------------------#
- ZONE=$(timedatectl 2>/dev/null|grep Timezone|awk '{print $2}')
- if [ -z "$ZONE" ]; then
- ZONE='UTC'
- fi
- for pconf in $(find /etc/php* -name php.ini); do
- sed -i "s%;date.timezone =%date.timezone = $ZONE%g" $pconf
- sed -i 's%_open_tag = Off%_open_tag = On%g' $pconf
- done
- #----------------------------------------------------------#
- # Configure Vsftpd #
- #----------------------------------------------------------#
- if [ "$vsftpd" = 'yes' ]; then
- cp -f $hestiacp/vsftpd/vsftpd.conf /etc/
- touch /var/log/vsftpd.log
- chown root:adm /var/log/vsftpd.log
- chmod 640 /var/log/vsftpd.log
- touch /var/log/xferlog
- chown root:adm /var/log/xferlog
- chmod 640 /var/log/xferlog
- update-rc.d vsftpd defaults
- service vsftpd start
- check_result $? "vsftpd start failed"
- fi
- #----------------------------------------------------------#
- # Configure ProFTPD #
- #----------------------------------------------------------#
- if [ "$proftpd" = 'yes' ]; then
- echo "127.0.0.1 $servername" >> /etc/hosts
- cp -f $hestiacp/proftpd/proftpd.conf /etc/proftpd/
- update-rc.d proftpd defaults > /dev/null 2>&1
- service proftpd start >> $LOG
- check_result $? "proftpd start failed"
- fi
- #----------------------------------------------------------#
- # Configure MariaDB #
- #----------------------------------------------------------#
- if [ "$mysql" = 'yes' ]; then
- mycnf="my-small.cnf"
- if [ $memory -gt 1200000 ]; then
- mycnf="my-medium.cnf"
- fi
- if [ $memory -gt 3900000 ]; then
- mycnf="my-large.cnf"
- fi
- # Configuring MariaDB
- cp -f $hestiacp/mysql/$mycnf /etc/mysql/my.cnf
- mysql_install_db >> $LOG
- update-rc.d mysql defaults
- service mysql start
- check_result $? "mariadb start failed"
- # Securing MariaDB installation
- mpass=$(gen_pass)
- mysqladmin -u root password $mpass >> $LOG
- echo -e "[client]\npassword='$mpass'\n" > /root/.my.cnf
- chmod 600 /root/.my.cnf
- # Clear MariaDB Test Users and Databases
- mysql -e "DELETE FROM mysql.user WHERE User=''"
- mysql -e "DROP DATABASE test" > /dev/null 2>&1
- mysql -e "DELETE FROM mysql.db WHERE Db='test' OR Db='test\\_%'"
- mysql -e "DELETE FROM mysql.user WHERE user='';"
- mysql -e "DELETE FROM mysql.user WHERE password='' AND authentication_string='';"
- # Configuring phpMyAdmin
- if [ "$apache" = 'yes' ]; then
- cp -f $hestiacp/pma/apache.conf /etc/phpmyadmin/
- ln -s /etc/phpmyadmin/apache.conf /etc/apache2/conf.d/phpmyadmin.conf
- fi
- cp -f $hestiacp/pma/config.inc.php /etc/phpmyadmin/
- chmod 777 /var/lib/phpmyadmin/tmp
- fi
- #----------------------------------------------------------#
- # Update phpMyAdmin #
- #----------------------------------------------------------#
- # Display upgrade information
- echo "Upgrade phpMyAdmin to v$pma_v..."
- # Download latest phpmyadmin release
- wget --quiet https://files.phpmyadmin.net/phpMyAdmin/$pma_v/phpMyAdmin-$pma_v-all-languages.tar.gz
- # Unpack files
- tar xzf phpMyAdmin-$pma_v-all-languages.tar.gz
- # Delete file to prevent error
- if [ "$pma_v" = '4.8.3' ]; then
- rm -fr /usr/share/phpmyadmin/doc/html
- fi
- # Overwrite old files
- cp -rf phpMyAdmin-$pma_v-all-languages/* /usr/share/phpmyadmin
- # Set config and log directory
- sed -i "s|define('CONFIG_DIR', '');|define('CONFIG_DIR', '/etc/phpmyadmin/');|" /usr/share/phpmyadmin/libraries/vendor_config.php
- sed -i "s|define('TEMP_DIR', './tmp/');|define('TEMP_DIR', '/var/lib/phpmyadmin/tmp/');|" /usr/share/phpmyadmin/libraries/vendor_config.php
- # Create temporary folder and change permission
- mkdir /usr/share/phpmyadmin/tmp
- chmod 777 /usr/share/phpmyadmin/tmp
- # Clear Up
- rm -fr phpMyAdmin-$pma_v-all-languages
- rm -f phpMyAdmin-$pma_v-all-languages.tar.gz
- #----------------------------------------------------------#
- # Configure PostgreSQL #
- #----------------------------------------------------------#
- if [ "$postgresql" = 'yes' ]; then
- ppass=$(gen_pass)
- cp -f $hestiacp/postgresql/pg_hba.conf /etc/postgresql/*/main/
- service postgresql restart
- sudo -u postgres psql -c "ALTER USER postgres WITH PASSWORD '$ppass'"
- # Configuring phpPgAdmin
- if [ "$apache" = 'yes' ]; then
- cp -f $hestiacp/pga/phppgadmin.conf /etc/apache2/conf.d/
- fi
- cp -f $hestiacp/pga/config.inc.php /etc/phppgadmin/
- fi
- #----------------------------------------------------------#
- # Configure Bind #
- #----------------------------------------------------------#
- if [ "$named" = 'yes' ]; then
- cp -f $hestiacp/bind/named.conf /etc/bind/
- cp -f $hestiacp/bind/named.conf.options /etc/bind/
- chown root:bind /etc/bind/named.conf
- chown root:bind /etc/bind/named.conf.options
- chmod 640 /etc/bind/named.conf
- chmod 640 /etc/bind/named.conf.options
- aa-complain /usr/sbin/named > /dev/null 2>&1
- echo "/home/** rwm," >> /etc/apparmor.d/local/usr.sbin.named 2>/dev/null
- service apparmor status >> $LOG
- if [ $? -ne 0 ]; then
- service apparmor restart
- fi
- update-rc.d bind9 defaults
- service bind9 start
- check_result $? "bind9 start failed"
- # Workaround for OpenVZ/Virtuozzo
- if [ -e "/proc/vz/veinfo" ]; then
- sed -i "s/^exit 0/service bind9 restart\nexit 0/" /etc/rc.local
- fi
- fi
- #----------------------------------------------------------#
- # Configure Exim #
- #----------------------------------------------------------#
- if [ "$exim" = 'yes' ]; then
- gpasswd -a Debian-exim mail > /dev/null 2>&1
- cp -f $hestiacp/exim/exim4.conf.template /etc/exim4/
- cp -f $hestiacp/exim/dnsbl.conf /etc/exim4/
- cp -f $hestiacp/exim/spam-blocks.conf /etc/exim4/
- touch /etc/exim4/white-blocks.conf
- if [ "$spamd" = 'yes' ]; then
- sed -i "s/#SPAM/SPAM/g" /etc/exim4/exim4.conf.template
- fi
- if [ "$clamd" = 'yes' ]; then
- sed -i "s/#CLAMD/CLAMD/g" /etc/exim4/exim4.conf.template
- fi
- chmod 640 /etc/exim4/exim4.conf.template
- rm -rf /etc/exim4/domains
- mkdir -p /etc/exim4/domains
- rm -f /etc/alternatives/mta
- ln -s /usr/sbin/exim4 /etc/alternatives/mta
- update-rc.d -f sendmail remove > /dev/null 2>&1
- service sendmail stop >> $LOG
- update-rc.d -f postfix remove > /dev/null 2>&1
- service postfix stop >> $LOG
- update-rc.d exim4 defaults
- service exim4 start
- check_result $? "exim4 start failed"
- fi
- #----------------------------------------------------------#
- # Configure Dovecot #
- #----------------------------------------------------------#
- if [ "$dovecot" = 'yes' ]; then
- gpasswd -a dovecot mail > /dev/null 2>&1
- cp -rf $hestiacp/dovecot /etc/
- cp -f $hestiacp/logrotate/dovecot /etc/logrotate.d/
- if [ "$release" = '18.04' ]; then
- rm -f /etc/dovecot/conf.d/15-mailboxes.conf
- fi
- chown -R root:root /etc/dovecot*
- update-rc.d dovecot defaults
- service dovecot start
- check_result $? "dovecot start failed"
- fi
- #----------------------------------------------------------#
- # Configure ClamAV #
- #----------------------------------------------------------#
- if [ "$clamd" = 'yes' ]; then
- gpasswd -a clamav mail > /dev/null 2>&1
- gpasswd -a clamav Debian-exim > /dev/null 2>&1
- cp -f $hestiacp/clamav/clamd.conf /etc/clamav/
- update-rc.d clamav-daemon defaults
- echo "Updating ClamAV..."
- /usr/bin/freshclam >> $LOG
- service clamav-daemon start
- check_result $? "clamav-daemon start failed"
- fi
- #----------------------------------------------------------#
- # Configure SpamAssassin #
- #----------------------------------------------------------#
- if [ "$spamd" = 'yes' ]; then
- update-rc.d spamassassin defaults > /dev/null 2>&1
- sed -i "s/ENABLED=0/ENABLED=1/" /etc/default/spamassassin
- service spamassassin start >> $LOG
- check_result $? "spamassassin start failed"
- unit_files="$(systemctl list-unit-files |grep spamassassin)"
- if [[ "$unit_files" =~ "disabled" ]]; then
- systemctl enable spamassassin > /dev/null 2>&1
- fi
- fi
- #----------------------------------------------------------#
- # Configure Roundcube #
- #----------------------------------------------------------#
- if [ "$exim" = 'yes' ] && [ "$mysql" = 'yes' ]; then
- if [ "$apache" = 'yes' ]; then
- cp -f $hestiacp/roundcube/apache.conf /etc/roundcube/
- ln -s /etc/roundcube/apache.conf /etc/apache2/conf.d/roundcube.conf
- fi
- cp -f $hestiacp/roundcube/main.inc.php /etc/roundcube/
- cp -f $hestiacp/roundcube/db.inc.php /etc/roundcube/
- chmod 640 /etc/roundcube/debian-db*
- chown root:www-data /etc/roundcube/debian-db*
- cp -f $hestiacp/roundcube/hestia.php \
- /usr/share/roundcube/plugins/password/drivers/
- cp -f $hestiacp/roundcube/config.inc.php /etc/roundcube/plugins/password/
- r="$(gen_pass)"
- mysql -e "CREATE DATABASE roundcube"
- mysql -e "GRANT ALL ON roundcube.*
- TO roundcube@localhost IDENTIFIED BY '$r'"
- sed -i "s/%password%/$r/g" /etc/roundcube/db.inc.php
- # Send all emails through SMTP and add user information
- sed -i "/\$config\['smtp_server'\]/c\$config\['smtp_server'\] = 'localhost';" /etc/roundcube/defaults.inc.php
- sed -i "/\$config\['smtp_user'\]/c\$config\['smtp_user'\] = '%u';" /etc/roundcube/defaults.inc.php
- sed -i "/\$config\['smtp_pass'\]/c\$config\['smtp_pass'\] = '%p';" /etc/roundcube/defaults.inc.php
- touch /var/log/roundcube/errors
- chmod 640 /var/log/roundcube/errors
- chown www-data:adm /var/log/roundcube/errors
- if [ "$release" = '16.04' ] || [ "$release" = '18.04' ]; then
- mv /etc/roundcube/db.inc.php /etc/roundcube/debian-db-roundcube.php
- mv /etc/roundcube/main.inc.php /etc/roundcube/config.inc.php
- chmod 640 /etc/roundcube/debian-db-roundcube.php
- chown root:www-data /etc/roundcube/debian-db-roundcube.php
- fi
- mysql roundcube < /usr/share/dbconfig-common/data/roundcube/install/mysql
- phpenmod mcrypt 2>/dev/null
- if [ "$apache" = 'yes' ]; then
- service apache2 restart
- fi
- if [ "$nginx" = 'yes' ]; then
- service nginx restart
- fi
- fi
- #----------------------------------------------------------#
- # Configure Fail2Ban #
- #----------------------------------------------------------#
- if [ "$fail2ban" = 'yes' ]; then
- cp -rf $hestiacp/fail2ban /etc/
- if [ "$dovecot" = 'no' ]; then
- fline=$(cat /etc/fail2ban/jail.local |grep -n dovecot-iptables -A 2)
- fline=$(echo "$fline" |grep enabled |tail -n1 |cut -f 1 -d -)
- sed -i "${fline}s/true/false/" /etc/fail2ban/jail.local
- fi
- if [ "$exim" = 'no' ]; then
- fline=$(cat /etc/fail2ban/jail.local |grep -n exim-iptables -A 2)
- fline=$(echo "$fline" |grep enabled |tail -n1 |cut -f 1 -d -)
- sed -i "${fline}s/true/false/" /etc/fail2ban/jail.local
- fi
- if [ "$vsftpd" = 'yes' ]; then
- #Create vsftpd Log File
- if [ ! -f "/var/log/vsftpd.log" ]; then
- touch /var/log/vsftpd.log
- fi
- fline=$(cat /etc/fail2ban/jail.local |grep -n vsftpd-iptables -A 2)
- fline=$(echo "$fline" |grep enabled |tail -n1 |cut -f 1 -d -)
- sed -i "${fline}s/false/true/" /etc/fail2ban/jail.local
- fi
- update-rc.d fail2ban defaults
- service fail2ban start
- check_result $? "fail2ban start failed"
- fi
- #----------------------------------------------------------#
- # Configure API #
- #----------------------------------------------------------#
- if [ "$api" = 'yes' ]; then
- echo "API='yes'" >> $HESTIA/conf/hestia.conf
- else
- rm -r $HESTIA/web/api
- echo "API='no'" >> $HESTIA/conf/hestia.conf
- fi
- #----------------------------------------------------------#
- # Fix phpmyadmin #
- #----------------------------------------------------------#
- # Special thanks to Pavel Galkin (https://skurudo.ru)
- # https://github.com/skurudo/phpmyadmin-fixer
- source $hestiacp/phpmyadmin/pma.sh >> $LOG
- #----------------------------------------------------------#
- # Configure Admin User #
- #----------------------------------------------------------#
- # Deleting old admin user
- if [ ! -z "$(grep ^admin: /etc/passwd)" ] && [ "$force" = 'yes' ]; then
- chattr -i /home/admin/conf > /dev/null 2>&1
- userdel -f admin > /dev/null 2>&1
- chattr -i /home/admin/conf > /dev/null 2>&1
- mv -f /home/admin $hst_backups/home/ > /dev/null 2>&1
- rm -f /tmp/sess_* > /dev/null 2>&1
- fi
- if [ ! -z "$(grep ^admin: /etc/group)" ] && [ "$force" = 'yes' ]; then
- groupdel admin > /dev/null 2>&1
- fi
- # Adding Hestia admin account
- $HESTIA/bin/v-add-user admin $vpass $email default System Administrator
- check_result $? "can't create admin user"
- $HESTIA/bin/v-change-user-shell admin nologin
- $HESTIA/bin/v-change-user-language admin $lang
- # Configuring system IPs
- $HESTIA/bin/v-update-sys-ip >> $LOG
- # Get main IP
- ip=$(ip addr|grep 'inet '|grep global|head -n1|awk '{print $2}'|cut -f1 -d/)
- # Configuring firewall
- if [ "$iptables" = 'yes' ]; then
- $HESTIA/bin/v-update-firewall
- fi
- # Get public IP
- pub_ip=$(curl --ipv4 -s https://www.hestiacp.com/what-is-my-ip/)
- if [ ! -z "$pub_ip" ] && [ "$pub_ip" != "$ip" ]; then
- echo "$HESTIA/bin/v-update-sys-ip" >> /etc/rc.local
- $HESTIA/bin/v-change-sys-ip-nat $ip $pub_ip >> $LOG
- ip=$pub_ip
- fi
- # Configuring MariaDB host
- if [ "$mysql" = 'yes' ]; then
- $HESTIA/bin/v-add-database-host mysql localhost root $mpass
- fi
- # Configuring PostgreSQL host
- if [ "$postgresql" = 'yes' ]; then
- $HESTIA/bin/v-add-database-host pgsql localhost postgres $ppass
- fi
- # Adding default domain
- $HESTIA/bin/v-add-web-domain admin $servername
- check_result $? "can't create $servername domain"
- # Adding cron jobs
- command="sudo $HESTIA/bin/v-update-sys-queue disk"
- $HESTIA/bin/v-add-cron-job 'admin' '15' '02' '*' '*' '*' "$command"
- command="sudo $HESTIA/bin/v-update-sys-queue traffic"
- $HESTIA/bin/v-add-cron-job 'admin' '10' '00' '*' '*' '*' "$command"
- command="sudo $HESTIA/bin/v-update-sys-queue webstats"
- $HESTIA/bin/v-add-cron-job 'admin' '30' '03' '*' '*' '*' "$command"
- command="sudo $HESTIA/bin/v-update-sys-queue backup"
- $HESTIA/bin/v-add-cron-job 'admin' '*/5' '*' '*' '*' '*' "$command"
- command="sudo $HESTIA/bin/v-backup-users"
- $HESTIA/bin/v-add-cron-job 'admin' '10' '05' '*' '*' '*' "$command"
- command="sudo $HESTIA/bin/v-update-user-stats"
- $HESTIA/bin/v-add-cron-job 'admin' '20' '00' '*' '*' '*' "$command"
- command="sudo $HESTIA/bin/v-update-sys-rrd"
- $HESTIA/bin/v-add-cron-job 'admin' '*/5' '*' '*' '*' '*' "$command"
- service cron restart
- # Building initital rrd images
- $HESTIA/bin/v-update-sys-rrd
- # Enabling file system quota
- if [ "$quota" = 'yes' ]; then
- $HESTIA/bin/v-add-sys-quota
- fi
- # Set backend port
- $HESTIA/bin/v-change-sys-port $port
- # Starting Hestia service
- update-rc.d hestia defaults
- service hestia start
- check_result $? "hestia start failed"
- chown admin:admin $HESTIA/data/sessions
- # Adding cronjob for autoupdates
- $HESTIA/bin/v-add-cron-hestia-autoupdate
- #----------------------------------------------------------#
- # Hestia Access Info #
- #----------------------------------------------------------#
- # Comparing hostname and IP
- host_ip=$(host $servername| head -n 1 |awk '{print $NF}')
- if [ "$host_ip" = "$ip" ]; then
- ip="$servername"
- fi
- # Sending notification to admin email
- echo -e "Congratulations, you have just successfully installed \
- Hestia Control Panel
- https://$ip:$port
- username: admin
- password: $vpass
- We hope that you enjoy your installation of Hestia. Please \
- feel free to contact us anytime if you have any questions.
- Thank you.
- --
- Sincerely yours
- hestiacp.com team
- " > $tmpfile
- send_mail="$HESTIA/web/inc/mail-wrapper.php"
- cat $tmpfile | $send_mail -s "Hestia Control Panel" $email
- # Congrats
- echo
- cat $tmpfile
- rm -f $tmpfile
- # EOF
|